'*******************************************************************************
'**                      RJ45 TESTER        09.2012                           **
'** ------------------------------------------------------------------------- **
'** Autor: Pawe Gobiewski                                                  **
'** email: info@elpag.com.pl                                                  **
'** --------------------------------------------------------------------------**
'** uP:  Attiny4313-SU   (2313 te OK)                                        **
'**                                                                           **
'** Para1 to piny 1-2   LED1                                                  **
'** Para2 to piny 3-6   LED2                                                  **
'** Para3 to piny 4-5   LED3                                                  **
'** Para4 to piny 7-8   LED4                                                  **
'**                                                                           **
'*******************************************************************************
'
$regfile = "attiny4313.dat"
$crystal = 1000000
$hwstack = 40
$swstack = 16
$framesize = 32

'------------------------------------------------------------------------------

Config Portb = &B11111111               'cay port B jako wyjcia
Config Portd = &B1011011                'PD2 i PD6 jako wejcia

Config Int0 = Low Level                 'konfig przerwania na stan niski
Enable Interrupts                       'zezwolenie na przerwania
Enable Int0
On Int0 Work                            'po wystpieniu przerwania wykonaj podprogram /Work/

'konfiguracja Timera1 jako licznika impulsw z wejcia T1
Config Timer1 = Counter , Edge = Rising

Dim Bateria As Bit                      'zmienna Bateria obrazujca stan zasilania
Dim Para1 As Bit                        'Para1
Dim Para2 As Bit                        'Para2
Dim Para3 As Bit                        'Para3
Dim Para4 As Bit                        'Para4
Dim A As Byte                           'zmienna dla ptli FOR
Dim C As Word                           'zmienna do ktrej porwnywany jest licznik po pomiarze pary

Led1 Alias Portb.4                      'przypisanie portom aliasw
Led2 Alias Portb.5
Led3 Alias Portb.6
Led4 Alias Portb.7

Declare Sub Low_battery                 'podprogram sygnalizujcy sab bateri
Declare Sub Pass_test                   'pomiar OK
Declare Sub No_connect                  'pomiar nie OK   -zcze RJ45 nie OK

Bateria = 0
Para1 = 0
Para2 = 0
Para3 = 0
Para4 = 0
C = 0

Do
   Portb = &B11111111                   'ustaw odpow. stany na pinach
   Portd = &B0111111                    'ustaw odpow. stany na pinach,
                                        'PD6-stan niski aby wyczy generator
   Powerdown
Loop

Work:
   Timer1 = 0                           'wyzeruj licznik
   Bateria = 0
   Para1 = 0
   Para2 = 0
   Para3 = 0
   Para4 = 0
   Reset Portd.6                        'wycz generator schmitta               
   Waitms 10
   Set Portd.6                          'wcz generator


'**************Sprawdzanie stanu baterii****************************************
   Portb = &B00001111                   'wcz LEDy -obcienie do pomiaru U
   Waitms 100
   Timer1 = 0                           'wyzeruj Timer1
   Start Timer1                         'zacznij zliczac impulsy na T1
   Waitms 500                           'zliczaj przez ok. 500 milisekund
   Stop Timer1                          'zakoncz liczenie

      If Timer1 < 6500 Then             'jeli Timer1 zliczyl mniej ni 6500 to
      Bateria = 0
      Call Low_battery
      Else
      Bateria = 1
      C = Timer1 - 1000                 'odejmowana warto utosamiana jest z czuoci testera
      End If
   Portb = &B11111111

'**************Sprawdzanie Pary1************************************************
If Bateria = 1 Then
   Reset Portb.0                        'zacz przekaznik K1
   Waitms 100
   Timer1 = 0                           'wyzeruj Timer1
   Start Timer1
   Waitms 500
   Stop Timer1

      If Timer1 < C Then                'jeli Timer1 zliczyl mniej ni warto C to
                                          'mona uzna e piny 1-2 s poczone
                                          'z par 1
      Para1 = 1
      Else
      Para1 = 0
      End If
   Set Portb.0                          'odcz przekaznik od generatora
End If

'**************Sprawdzanie Pary2************************************************
If Bateria = 1 Then
   Reset Portb.1                        'zacz przekaznik K2
   Waitms 100
   Timer1 = 0                           'wyzeruj Timer1
   Start Timer1
   Waitms 500
   Stop Timer1

      If Timer1 < C Then                'jeli Timer1 zliczyl mniej ni warto C to
                                          'mona uzna e piny 3-6 s poczone
                                          'z par 2
      Para2 = 1
      Else
      Para2 = 0
      End If
   Set Portb.1                          'odcz przekaznik od generatora
End If

'**************Sprawdzanie Pary3************************************************
If Bateria = 1 Then
   Reset Portb.2                        'zacz przekaznik K3
   Waitms 100
   Timer1 = 0                           'wyzeruj Timer1
   Start Timer1
   Waitms 500
   Stop Timer1

      If Timer1 < C Then                'jeli Timer1 zliczyl mniej ni warto C to
                                          'mona uzna e piny 4-5 s poczone
                                          'z par 3
      Para3 = 1
      Else
      Para3 = 0
      End If
   Set Portb.2                          'odcz przekaznik od generatora
End If

'**************Sprawdzanie Pary4************************************************
If Bateria = 1 Then
   Reset Portb.3                        'zacz przekaznik K4
   Waitms 100
   Timer1 = 0                           'wyzeruj Timer1
   Start Timer1
   Waitms 500
   Stop Timer1

      If Timer1 < C Then                'jeli Timer1 zliczyl mniej ni warto C to
                                          'mona uzna e piny 7-8 s poczone
                                          'z par 4
      Para4 = 1
      Else
      Para4 = 0
      End If
   Set Portb.3                          'odcz przekaznik od generatora
End If

'***************Sygnalizacja pomiarw*******************************************
Led1 = Para1
Led2 = Para2
Led3 = Para3
Led4 = Para4

If Portb = 255 Then
   Call Pass_test
   Elseif Bateria = 1 Then
   Call No_connect
End If

Return

End

'_______________________________________________________________________________

Sub Low_battery                         'sygna sos
Portb = &B11111111
   Reset Portd.4
   Reset Portd.0
   Waitms 100
   Set Portd.4
   Set Portd.0
   Waitms 100
   Reset Portd.4
   Reset Portd.0
   Waitms 100
   Set Portd.4
   Set Portd.0
   Waitms 100
   Reset Portd.4
   Reset Portd.0
   Waitms 100
   Set Portd.4
   Set Portd.0
   Waitms 100
   Reset Portd.4
   Reset Portd.0
   Waitms 200
   Set Portd.4
   Set Portd.0
   Waitms 200
   Reset Portd.4
   Reset Portd.0
   Waitms 200
   Set Portd.4
   Set Portd.0
   Waitms 200
   Reset Portd.4
   Reset Portd.0
   Waitms 200
   Set Portd.4
   Set Portd.0
   Waitms 200
   Reset Portd.4
   Reset Portd.0
   Waitms 100
   Set Portd.4
   Set Portd.0
   Waitms 100
   Reset Portd.4
   Reset Portd.0
   Waitms 100
   Set Portd.4
   Set Portd.0
   Waitms 100
   Reset Portd.4
   Reset Portd.0
   Waitms 100
   Set Portd.4
   Set Portd.0
   Waitms 100
   For A = 1 To 50
   Waitms 100
   Toggle Portd.0
   Next A
End Sub

Sub Pass_test
   Reset Portd.4
   Waitms 50
   Set Portd.4
   Waitms 50
   Reset Portd.4
   Waitms 50
   Set Portd.4
   Waitms 50
   Reset Portd.4
   Waitms 50
   Set Portd.4
   Waitms 50
   For A = 1 To 20
   Waitms 100
   Toggle Portd.1
   Next A
End Sub

Sub No_connect

   Reset Portd.4
   Waitms 200
   Set Portd.4
   Waitms 200
   Reset Portd.4
   Waitms 800
   Set Portd.4

   For A = 1 To 20

   If Para1 = 0 Then
   Toggle Led1
   End If

   If Para2 = 0 Then
   Toggle Led2
   End If

   If Para3 = 0 Then
   Toggle Led3
   End If

   If Para4 = 0 Then
   Toggle Led4
   End If

   Waitms 200
   Next A

End Sub